REM Drive/Directory/Filename Menu box v1.0a PD 2002.

' get include file.
REM $INCLUDE: 'hexedit.inc'

SUB Menu (C$, D$, X$, E$)

' display menu screen
GOSUB MainMenu

' get current drive/directory
GOSUB InitDrive
GOSUB InitDir

' read all subdirectories
Current.Dir = 1
Dir.Box.Line = 1
GOSUB ClearDirBox
GOSUB LoadDirSpec
GOSUB DisplayDirSpec
GOSUB DisplayCurrentDir

' display first ten files
IF D$ = "" THEN
   F$ = C$ + ":\*.*"
ELSE
   F$ = C$ + ":\" + D$ + "\" + "*.*"
END IF
GOSUB ClearFileBox
GOSUB LoadFileSpec
GOSUB DisplayFileSpec

' main input loop
X$ = "*.*"
LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
PRINT SPACE$(12);
LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
PRINT X$;
DO
   LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
   PRINT SPACE$(12);
   LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
   PRINT X$;
   DO
      I$ = ""
      DO
         I$ = INKEY$
         IF LEN(I$) THEN
            EXIT DO
         END IF
      LOOP
      IF LEN(I$) = 2 THEN
         I$ = ""
      END IF
      IF I$ = CHR$(9) THEN
         IF Num.Files > 0 THEN
            GOSUB FileInputLoop
         ELSE
            GOSUB DirInputLoop
            IF I$ = CHR$(13) THEN
               I$ = ""
               Current.Dir = 1
               Dir.Box.Line = 1
               GOSUB ClearDirBox
               GOSUB LoadDirSpec
               GOSUB DisplayDirSpec
               GOSUB DisplayCurrentDir
            END IF
         END IF
         EXIT DO
      END IF
      IF I$ = CHR$(13) THEN
         I$ = ""
         EXIT DO
      END IF
      IF I$ = CHR$(27) THEN
         EXIT DO
      END IF
      IF I$ = CHR$(8) THEN
         IF LEN(X$) > 0 THEN
            X$ = LEFT$(X$, LEN(X$) - 1)
            LOCATE CSRLIN, POS(0) - 1, 1
            PRINT " ";
            LOCATE CSRLIN, POS(0) - 1, 1
         END IF
      ELSE
         I$ = LTRIM$(I$)
         I$ = RTRIM$(I$)
         I$ = UCASE$(I$)
         IF LEN(X$) < 12 THEN
            PRINT I$;
            X$ = X$ + I$
         END IF
      END IF
   LOOP
   IF I$ = CHR$(27) THEN
      E$ = ""
      EXIT DO
   END IF
   IF I$ = CHR$(13) THEN
      EXIT DO
   END IF
   GOSUB StripName
   IF D$ = "" THEN
      F$ = C$ + ":\" + X$
   ELSE
      F$ = C$ + ":\" + D$ + "\" + X$
   END IF
   GOSUB ClearFileBox
   GOSUB LoadFileSpec
   GOSUB DisplayFileSpec
LOOP
COLOR 7, 0
CLS
EXIT SUB

FileInputLoop:
 E$ = Filenames(1)
 E$ = RTRIM$(E$)
 COLOR 7, 0
 LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
 PRINT SPACE$(12);
 LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
 PRINT E$;
 COLOR 0, 7
 LOCATE 6 + Xcoor - 1, 4 + Ycoor - 1, 1
 PRINT E$;
 COLOR 7, 0
 Current.File = 1
 File.Box.Line = 1
 E$ = RTRIM$(Filenames(1))
 I$ = ""
 DO
    DO
       I$ = INKEY$
       IF LEN(I$) THEN
          EXIT DO
       END IF
    LOOP
    IF I$ = CHR$(9) THEN
       GOSUB DirInputLoop
       IF I$ = CHR$(9) THEN
          RETURN
       END IF
       IF I$ = CHR$(13) THEN
          I$ = ""
          Current.Dir = 1
          Dir.Box.Line = 1
          GOSUB ClearDirBox
          GOSUB LoadDirSpec
          GOSUB DisplayDirSpec
          GOSUB DisplayCurrentDir
          RETURN
       END IF
    END IF
    IF I$ = CHR$(13) THEN
       RETURN
    END IF
    IF I$ = CHR$(27) THEN
       RETURN
    END IF
    IF LEN(I$) = 2 THEN
       V = ASC(RIGHT$(I$, 1))
       SELECT CASE V
       CASE 72 ' up
          IF Current.File - 1 > 0 THEN
             IF File.Box.Line > 1 THEN
                LOCATE File.Box.Line + 5 + Xcoor - 1, 4 + Ycoor - 1, 1
                COLOR 7, 0
                PRINT RTRIM$(Filenames(Current.File));
                File.Box.Line = File.Box.Line - 1
                Current.File = Current.File - 1
                E$ = RTRIM$(Filenames(Current.File))
                COLOR 7, 0
                LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
                PRINT SPACE$(12);
                LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
                PRINT E$;
                LOCATE File.Box.Line + 5 + Xcoor - 1, 4 + Ycoor - 1, 1
                COLOR 0, 7
                PRINT E$;
                COLOR 7, 0
             ELSE
                Current.File = Current.File - 1
                E$ = RTRIM$(Filenames(Current.File))
                COLOR 7, 0
                LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
                PRINT SPACE$(12);
                LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
                PRINT E$;
                GOSUB ClearFileBox
                COLOR 7, 0
                FOR V = 1 TO 9
                   IF Current.File + V <= Num.Files THEN
                      LOCATE 6 + V + Xcoor - 1, 4 + Ycoor - 1, 1
                      PRINT RTRIM$(Filenames(Current.File + V));
                   END IF
                NEXT
                COLOR 0, 7
                LOCATE 6 + Xcoor - 1, 4 + Ycoor - 1, 1
                PRINT RTRIM$(Filenames(Current.File));
             END IF
          END IF
       CASE 80 ' down
          IF Current.File + 1 <= Num.Files THEN
             IF File.Box.Line < 10 THEN
                LOCATE File.Box.Line + 5 + Xcoor - 1, 4 + Ycoor - 1, 1
                COLOR 7, 0
                PRINT RTRIM$(Filenames(Current.File));
                File.Box.Line = File.Box.Line + 1
                Current.File = Current.File + 1
                E$ = RTRIM$(Filenames(Current.File))
                COLOR 7, 0
                LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
                PRINT SPACE$(12);
                LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
                PRINT E$;
                LOCATE File.Box.Line + 5 + Xcoor - 1, 4 + Ycoor - 1, 1
                COLOR 0, 7
                PRINT E$;
                COLOR 7, 0
             ELSE
                Current.File = Current.File + 1
                E$ = RTRIM$(Filenames(Current.File))
                COLOR 7, 0
                LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
                PRINT SPACE$(12);
                LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
                PRINT E$;
                GOSUB ClearFileBox
                COLOR 7, 0
                FOR V = 1 TO 9
                   LOCATE 15 - V + Xcoor - 1, 4 + Ycoor - 1, 1
                   PRINT RTRIM$(Filenames(Current.File - V));
                NEXT
                COLOR 0, 7
                LOCATE 15 + Xcoor - 1, 4 + Ycoor - 1, 1
                PRINT RTRIM$(Filenames(Current.File));
             END IF
          END IF
       CASE 73 ' pgup
          IF Current.File - 10 > 0 THEN
             File.Box.Line = 1
             Current.File = Current.File - 10
          ELSE
             File.Box.Line = 1
             Current.File = 1
          END IF
          E$ = RTRIM$(Filenames(Current.File))
          COLOR 7, 0
          LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
          PRINT SPACE$(12);
          LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
          PRINT E$;
          GOSUB ClearFileBox
          COLOR 7, 0
          FOR V = 1 TO 9
             IF Current.File + V <= Num.Files THEN
                LOCATE 6 + V + Xcoor - 1, 4 + Ycoor - 1, 1
                PRINT RTRIM$(Filenames(Current.File + V));
             END IF
          NEXT
          COLOR 0, 7
          LOCATE 6 + Xcoor - 1, 4 + Ycoor - 1, 1
          PRINT RTRIM$(Filenames(Current.File));
       CASE 81 ' pgdn
          IF Current.File + 10 <= Num.Files THEN
             File.Box.Line = 10
             Current.File = Current.File + 10
             E$ = RTRIM$(Filenames(Current.File))
             COLOR 7, 0
             LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
             PRINT SPACE$(12);
             LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
             PRINT E$;
             GOSUB ClearFileBox
             COLOR 7, 0
             FOR V = 1 TO 9
                LOCATE 15 - V + Xcoor - 1, 4 + Ycoor - 1, 1
                PRINT RTRIM$(Filenames(Current.File - V));
             NEXT
             COLOR 0, 7
             LOCATE 15 + Xcoor - 1, 4 + Ycoor - 1, 1
             PRINT RTRIM$(Filenames(Current.File));
          ELSE
             IF Current.File + 1 <= Num.Files THEN
                DO UNTIL Current.File = Num.Files
                   IF File.Box.Line < 10 THEN
                      LOCATE File.Box.Line + 5 + Xcoor - 1, 4 + Ycoor - 1, 1
                      COLOR 7, 0
                      PRINT RTRIM$(Filenames(Current.File));
                      File.Box.Line = File.Box.Line + 1
                      Current.File = Current.File + 1
                      E$ = RTRIM$(Filenames(Current.File))
                      COLOR 7, 0
                      LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
                      PRINT SPACE$(12);
                      LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
                      PRINT E$;
                      LOCATE File.Box.Line + 5 + Xcoor - 1, 4 + Ycoor - 1, 1
                      COLOR 0, 7
                      PRINT E$;
                      COLOR 7, 0
                   ELSE
                      Current.File = Current.File + 1
                      E$ = RTRIM$(Filenames(Current.File))
                      COLOR 7, 0
                      LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
                      PRINT SPACE$(12);
                      LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
                      PRINT E$;
                      GOSUB ClearFileBox
                      COLOR 7, 0
                      FOR V = 1 TO 9
                         LOCATE 15 - V + Xcoor - 1, 4 + Ycoor - 1, 1
                         PRINT RTRIM$(Filenames(Current.File - V));
                      NEXT
                      COLOR 0, 7
                      LOCATE 15 + Xcoor - 1, 4 + Ycoor - 1, 1
                      PRINT RTRIM$(Filenames(Current.File));
                   END IF
                LOOP
             END IF
          END IF
       CASE 71 ' home
          IF Current.File > 1 THEN
             File.Box.Line = 1
             Current.File = 1
          END IF
          E$ = RTRIM$(Filenames(Current.File))
          COLOR 7, 0
          LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
          PRINT SPACE$(12);
          LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
          PRINT E$;
          GOSUB ClearFileBox
          COLOR 7, 0
          FOR V = 1 TO 9
             IF Current.File + V <= Num.Files THEN
                LOCATE 6 + V + Xcoor - 1, 4 + Ycoor - 1, 1
                PRINT RTRIM$(Filenames(Current.File + V));
             END IF
          NEXT
          COLOR 0, 7
          LOCATE 6 + Xcoor - 1, 4 + Ycoor - 1, 1
          PRINT RTRIM$(Filenames(Current.File));
       CASE 79 ' end
          IF Current.File + 1 <= Num.Files THEN
             DO UNTIL Current.File = Num.Files
                IF File.Box.Line < 10 THEN
                   LOCATE File.Box.Line + 5 + Xcoor - 1, 4 + Ycoor - 1, 1
                   COLOR 7, 0
                   PRINT RTRIM$(Filenames(Current.File));
                   File.Box.Line = File.Box.Line + 1
                   Current.File = Current.File + 1
                   E$ = RTRIM$(Filenames(Current.File))
                   COLOR 7, 0
                   LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
                   PRINT SPACE$(12);
                   LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
                   PRINT E$;
                   LOCATE File.Box.Line + 5 + Xcoor - 1, 4 + Ycoor - 1, 1
                   COLOR 0, 7
                   PRINT E$;
                   COLOR 7, 0
                ELSE
                   Current.File = Current.File + 1
                   E$ = RTRIM$(Filenames(Current.File))
                   COLOR 7, 0
                   LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
                   PRINT SPACE$(12);
                   LOCATE 2 + Xcoor - 1, 13 + Ycoor - 1, 1
                   PRINT E$;
                   GOSUB ClearFileBox
                   COLOR 7, 0
                   FOR V = 1 TO 9
                      LOCATE 15 - V + Xcoor - 1, 4 + Ycoor - 1, 1
                      PRINT RTRIM$(Filenames(Current.File - V));
                   NEXT
                   COLOR 0, 7
                   LOCATE 15 + Xcoor - 1, 4 + Ycoor - 1, 1
                   PRINT RTRIM$(Filenames(Current.File));
                END IF
             LOOP
          END IF
       END SELECT
    END IF
 LOOP
 RETURN

DirInputLoop:
 Q$ = RTRIM$(Directories(Current.Dir))
 LOCATE Dir.Box.Line + 5 + Xcoor - 1, 21 + Ycoor - 1, 1
 COLOR 0, 7
 PRINT Q$;
 COLOR 7, 0
 I$ = ""
 DO
    DO
       I$ = INKEY$
       IF LEN(I$) THEN
          EXIT DO
       END IF
    LOOP
    IF I$ = CHR$(9) THEN
       LOCATE Dir.Box.Line + 5 + Xcoor - 1, 21 + Ycoor - 1, 1
       COLOR 7, 0
       PRINT RTRIM$(Directories(Current.Dir));
       RETURN
    END IF
    IF I$ = CHR$(13) THEN
       ' check the path type
       SELECT CASE Q$
       CASE "." ' self
          ' nul
       CASE ".." ' parent
          IF INSTR(D$, "\") = 0 THEN
             D$ = ""
          ELSE
             FOR V = LEN(D$) TO 1 STEP -1
                IF MID$(D$, V, 1) = "\" THEN
                   D$ = LEFT$(D$, V - 1)
                   EXIT FOR
                END IF
             NEXT
          END IF
       CASE ELSE ' imbedded path
          IF D$ = "" THEN
             D$ = Q$
          ELSE
             D$ = D$ + "\" + Q$
          END IF
       END SELECT
       RETURN
    END IF
    IF I$ = CHR$(27) THEN
       RETURN
    END IF
    IF LEN(I$) = 2 THEN
       V = ASC(RIGHT$(I$, 1))
       SELECT CASE V
       CASE 72 ' up
          IF Current.Dir - 1 > 0 THEN
             IF Dir.Box.Line > 1 THEN
                LOCATE Dir.Box.Line + 5 + Xcoor - 1, 21 + Ycoor - 1, 1
                COLOR 7, 0
                PRINT RTRIM$(Directories(Current.Dir));
                Dir.Box.Line = Dir.Box.Line - 1
                Current.Dir = Current.Dir - 1
                LOCATE Dir.Box.Line + 5 + Xcoor - 1, 21 + Ycoor - 1, 1
                COLOR 0, 7
                PRINT RTRIM$(Directories(Current.Dir));
                COLOR 7, 0
             ELSE
                GOSUB ClearDirBox
                Current.Dir = Current.Dir - 1
                COLOR 7, 0
                FOR V = 1 TO 9
                   IF Current.Dir + V <= Num.Dirs THEN
                      LOCATE 6 + V + Xcoor - 1, 21 + Ycoor - 1, 1
                      PRINT RTRIM$(Directories(Current.Dir + V));
                   END IF
                NEXT
                COLOR 0, 7
                LOCATE 6 + Xcoor - 1, 21 + Ycoor - 1, 1
                PRINT RTRIM$(Directories(Current.Dir));
                COLOR 7, 0
             END IF
             Q$ = RTRIM$(Directories(Current.Dir))
          END IF
       CASE 80 ' down
          IF Current.Dir + 1 <= Num.Dirs THEN
             IF Dir.Box.Line < 10 THEN
                LOCATE Dir.Box.Line + 5 + Xcoor - 1, 21 + Ycoor - 1, 1
                COLOR 7, 0
                PRINT RTRIM$(Directories(Current.Dir));
                Dir.Box.Line = Dir.Box.Line + 1
                Current.Dir = Current.Dir + 1
                LOCATE Dir.Box.Line + 5 + Xcoor - 1, 21 + Ycoor - 1, 1
                COLOR 0, 7
                PRINT RTRIM$(Directories(Current.Dir));
                COLOR 7, 0
             ELSE
                GOSUB ClearDirBox
                Current.Dir = Current.Dir + 1
                COLOR 7, 0
                FOR V = 1 TO 9
                   LOCATE 15 - V + Xcoor - 1, 21 + Ycoor - 1, 1
                   PRINT RTRIM$(Directories(Current.Dir - V));
                NEXT
                COLOR 0, 7
                LOCATE 15 + Xcoor - 1, 21 + Ycoor - 1, 1
                PRINT RTRIM$(Directories(Current.Dir));
                COLOR 7, 0
             END IF
             Q$ = RTRIM$(Directories(Current.Dir))
          END IF
       CASE 73 ' pgup
          IF Current.Dir - 10 > 0 THEN
             Dir.Box.Line = 1
             Current.Dir = Current.Dir - 10
          ELSE
             Dir.Box.Line = 1
             Current.Dir = 1
          END IF
          GOSUB ClearDirBox
          COLOR 7, 0
          FOR V = 1 TO 9
             IF Current.Dir + V <= Num.Dirs THEN
                LOCATE 6 + V + Xcoor - 1, 21 + Ycoor - 1, 1
                PRINT RTRIM$(Directories(Current.Dir + V));
             END IF
          NEXT
          COLOR 0, 7
          LOCATE 6 + Xcoor - 1, 21 + Ycoor - 1, 1
          PRINT RTRIM$(Directories(Current.Dir));
          COLOR 7, 0
          Q$ = RTRIM$(Directories(Current.Dir))
       CASE 81 ' pgdn
          IF Current.Dir + 10 <= Num.Dirs THEN
             GOSUB ClearDirBox
             Dir.Box.Line = 10
             Current.Dir = Current.Dir + 10
             COLOR 7, 0
             FOR V = 1 TO 9
                LOCATE 15 - V + Xcoor - 1, 21 + Ycoor - 1, 1
                PRINT RTRIM$(Directories(Current.Dir - V));
             NEXT
             COLOR 0, 7
             LOCATE 15 + Xcoor - 1, 21 + Ycoor - 1, 1
             PRINT RTRIM$(Directories(Current.Dir));
             COLOR 7, 0
             Q$ = RTRIM$(Directories(Current.Dir))
          ELSE
             IF Current.Dir + 1 <= Num.Dirs THEN
                DO UNTIL Current.Dir = Num.Dirs
                   IF Dir.Box.Line < 10 THEN
                      LOCATE Dir.Box.Line + 5 + Xcoor - 1, 21 + Ycoor - 1, 1
                      COLOR 7, 0
                      PRINT RTRIM$(Directories(Current.Dir));
                      Dir.Box.Line = Dir.Box.Line + 1
                      Current.Dir = Current.Dir + 1
                      LOCATE Dir.Box.Line + 5 + Xcoor - 1, 21 + Ycoor - 1, 1
                      COLOR 0, 7
                      PRINT RTRIM$(Directories(Current.Dir));
                      COLOR 7, 0
                   ELSE
                      GOSUB ClearDirBox
                      Current.Dir = Current.Dir + 1
                      COLOR 7, 0
                      FOR V = 1 TO 9
                         LOCATE 15 - V + Xcoor - 1, 21 + Ycoor - 1, 1
                         PRINT RTRIM$(Directories(Current.Dir - V));
                      NEXT
                      COLOR 0, 7
                      LOCATE 15 + Xcoor - 1, 21 + Ycoor - 1, 1
                      PRINT RTRIM$(Directories(Current.Dir));
                      COLOR 7, 0
                   END IF
                LOOP
                Q$ = RTRIM$(Directories(Current.Dir))
             END IF
          END IF
       CASE 71 ' home
          IF Current.Dir > 1 THEN
             Dir.Box.Line = 1
             Current.Dir = 1
          END IF
          GOSUB ClearDirBox
          COLOR 7, 0
          FOR V = 1 TO 9
             IF Current.Dir + V <= Num.Dirs THEN
                LOCATE 6 + V + Xcoor - 1, 21 + Ycoor - 1, 1
                PRINT RTRIM$(Directories(Current.Dir + V));
             END IF
          NEXT
          COLOR 0, 7
          LOCATE 6 + Xcoor - 1, 21 + Ycoor - 1, 1
          PRINT RTRIM$(Directories(Current.Dir));
          COLOR 7, 0
          Q$ = RTRIM$(Directories(Current.Dir))
       CASE 79 ' end
          IF Current.Dir + 1 <= Num.Dirs THEN
             DO UNTIL Current.Dir = Num.Dirs
                IF Dir.Box.Line < 10 THEN
                   LOCATE Dir.Box.Line + 5 + Xcoor - 1, 21 + Ycoor - 1, 1
                   COLOR 7, 0
                   PRINT RTRIM$(Directories(Current.Dir));
                   Dir.Box.Line = Dir.Box.Line + 1
                   Current.Dir = Current.Dir + 1
                   LOCATE Dir.Box.Line + 5 + Xcoor - 1, 21 + Ycoor - 1, 1
                   COLOR 0, 7
                   PRINT RTRIM$(Directories(Current.Dir));
                   COLOR 7, 0
                ELSE
                   GOSUB ClearDirBox
                   Current.Dir = Current.Dir + 1
                   COLOR 7, 0
                   FOR V = 1 TO 9
                      LOCATE 15 - V + Xcoor - 1, 21 + Ycoor - 1, 1
                      PRINT RTRIM$(Directories(Current.Dir - V));
                   NEXT
                   COLOR 0, 7
                   LOCATE 15 + Xcoor - 1, 21 + Ycoor - 1, 1
                   PRINT RTRIM$(Directories(Current.Dir));
                   COLOR 7, 0
                END IF
             LOOP
             Q$ = RTRIM$(Directories(Current.Dir))
          END IF
       END SELECT
    END IF
 LOOP
 RETURN

MainMenu:
' define screen offsets,
' allows menu centering.
Xcoor = 5
Ycoor = 20
' draw menu
COLOR , 1
CLS
LOCATE Xcoor, Ycoor
COLOR , 0
COLOR 14
PRINT CHR$(ULcorner) + STRING$(33, Hline) + CHR$(URcorner)
LOCATE Xcoor + 1, Ycoor
PRINT CHR$(Vline) + " ";
COLOR 15
PRINT "Filename:";
COLOR 14
PRINT "                       " + CHR$(Vline)
LOCATE Xcoor + 2, Ycoor
PRINT CHR$(Vline) + "                                 " + CHR$(Vline)
LOCATE Xcoor + 3, Ycoor
PRINT CHR$(Vline) + " ";
COLOR 15
PRINT "Files:           Directories:   ";
COLOR 14
PRINT CHR$(Vline)
LOCATE Xcoor + 4, Ycoor
PRINT CHR$(Vline);
COLOR 13
PRINT " " + CHR$(ULcorner) + STRING$(12, Hline) + CHR$(URcorner) + "   ";
PRINT CHR$(ULcorner) + STRING$(12, Hline) + CHR$(URcorner) + " ";
COLOR 14
PRINT CHR$(Vline)
COLOR 14
LOCATE Xcoor + 5, Ycoor
PRINT CHR$(Vline);
COLOR 13
PRINT " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "   " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + " ";
COLOR 14
PRINT CHR$(Vline)
COLOR 14
LOCATE Xcoor + 6, Ycoor
PRINT CHR$(Vline);
COLOR 13
PRINT " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "   " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + " ";
COLOR 14
PRINT CHR$(Vline)
COLOR 14
LOCATE Xcoor + 7, Ycoor
PRINT CHR$(Vline);
COLOR 13
PRINT " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "   " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + " ";
COLOR 14
PRINT CHR$(Vline)
COLOR 14
LOCATE Xcoor + 8, Ycoor
PRINT CHR$(Vline);
COLOR 13
PRINT " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "   " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + " ";
COLOR 14
PRINT CHR$(Vline)
COLOR 14
LOCATE Xcoor + 9, Ycoor
PRINT CHR$(Vline);
COLOR 13
PRINT " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "   " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + " ";
COLOR 14
PRINT CHR$(Vline)
COLOR 14
LOCATE Xcoor + 10, Ycoor
PRINT CHR$(Vline);
COLOR 13
PRINT " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "   " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + " ";
COLOR 14
PRINT CHR$(Vline)
COLOR 14
LOCATE Xcoor + 11, Ycoor
PRINT CHR$(Vline);
COLOR 13
PRINT " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "   " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + " ";
COLOR 14
PRINT CHR$(Vline)
COLOR 14
LOCATE Xcoor + 12, Ycoor
PRINT CHR$(Vline);
COLOR 13
PRINT " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "   " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + " ";
COLOR 14
PRINT CHR$(Vline)
COLOR 14
LOCATE Xcoor + 13, Ycoor
PRINT CHR$(Vline);
COLOR 13
PRINT " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "   " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + " ";
COLOR 14
PRINT CHR$(Vline)
COLOR 14
LOCATE Xcoor + 14, Ycoor
PRINT CHR$(Vline);
COLOR 13
PRINT " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "   " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + " ";
COLOR 14
PRINT CHR$(Vline)
COLOR 14
LOCATE Xcoor + 15, Ycoor
PRINT CHR$(Vline);
COLOR 13
PRINT " " + CHR$(LLcorner) + STRING$(12, Hline) + CHR$(LRcorner) + "   ";
PRINT CHR$(LLcorner) + STRING$(12, Hline) + CHR$(LRcorner) + " ";
COLOR 14
PRINT CHR$(Vline)
LOCATE Xcoor + 16, Ycoor
PRINT CHR$(LLcorner) + STRING$(33, Hline) + CHR$(LRcorner)
COLOR 10, 1
LOCATE Xcoor + 17, Ycoor
PRINT "Hexedit v2.3a for QB v4.5a PD 2002.";
LOCATE Xcoor + 18, Ycoor
PRINT "<enter>=file/<tab>=window/<esc>=exit"
COLOR 7, 0
RETURN

' return current drive.
InitDrive:
 InregsX.AX = &H1900
 CALL InterruptX(&H21, InregsX, OutregsX)
 Drive.Number = OutregsX.AX AND &HFF
 C$ = CHR$(Drive.Number + 65)
 RETURN

' return current directory.
InitDir:
 InregsX.AX = &H4700
 InregsX.DX = Drive.Number + 1
 InregsX.DS = VARSEG(ASCIIZ3)
 InregsX.SI = VARPTR(ASCIIZ3)
 CALL InterruptX(&H21, InregsX, OutregsX)
 D$ = LEFT$(ASCIIZ3, INSTR(ASCIIZ3, CHR$(0)) - 1)
 RETURN

' load current subdirectories.
LoadDirSpec:
 REDIM Directories(1 TO 64) AS STRING * 64
 Max.Dirs = 64
 Num.Dirs = 0
 GOSUB SetDTA
 ' find first directory
 IF D$ = "" THEN
    ASCIIZ3 = C$ + ":\*.*" + CHR$(0)
 ELSE
    IF D$ = "\" THEN
       ASCIIZ3 = C$ + ":\*.*" + CHR$(0)
    ELSE
       ASCIIZ3 = C$ + ":\" + D$ + "\*.*" + CHR$(0)
    END IF
 END IF
 InregsX.AX = &H4E00
 InregsX.CX = &H37
 InregsX.DS = VARSEG(ASCIIZ3)
 InregsX.DX = VARPTR(ASCIIZ3)
 CALL InterruptX(&H21, InregsX, OutregsX)
 ' store directories
 DO
    ' check for directory
    Attribute = ASC(DTAfile.FileBits)
    IF (Attribute AND &H10) = &H10 THEN
       E$ = DTAfile.ASCIIZfilename
       E$ = LEFT$(E$, INSTR(E$, CHR$(0)) - 1)
       Num.Dirs = Num.Dirs + 1
       Directories(Num.Dirs) = E$
       IF Num.Dirs >= Max.Dirs THEN
          OPEN "hexedit1.dat" FOR OUTPUT AS #1
          FOR Var& = 1 TO Num.Dirs
             PRINT #1, Directories(Var&)
          NEXT
          CLOSE #1
          Max.Dirs = Max.Dirs + 64
          REDIM Directories(1 TO Max.Dirs) AS STRING * 64
          OPEN "hexedit1.dat" FOR INPUT AS #1
          FOR Var& = 1 TO Num.Dirs
             INPUT #1, Directories(Var&)
          NEXT
          CLOSE #1
       END IF
    END IF
    ' find next directory
    InregsX.AX = &H4F00
    CALL InterruptX(&H21, InregsX, OutregsX)
    ' check findnext error
    IF (OutregsX.Flags AND &H1) = &H1 THEN
       EXIT DO
    END IF
 LOOP
 GOSUB ResetDTA
 GOSUB Shell.Sort2
 RETURN
 ' bubble sort
 FOR V1 = 1 TO Num.Dirs
    FOR V2 = V1 + 1 TO Num.Dirs
       IF Directories(V1) > Directories(V2) THEN
          SWAP Directories(V1), Directories(V2)
       END IF
    NEXT
 NEXT
 RETURN

DisplayDirSpec:
 VarX = 0
 DO
    VarX = VarX + 1
    IF VarX > 10 THEN
       EXIT DO
    END IF
    IF VarX > Num.Dirs THEN
       EXIT DO
    END IF
    LOCATE VarX + 5 + Xcoor - 1, 21 + Ycoor - 1, 1
    E$ = Directories(VarX)
    E$ = RTRIM$(E$)
    PRINT E$;
 LOOP
 RETURN

ClearDirBox:
 FOR VarX = 1 TO 10
    LOCATE VarX + 5 + Xcoor - 1, 21 + Ycoor - 1, 1
    PRINT SPACE$(12);
 NEXT
 RETURN

DisplayCurrentDir:
 ' deconcatenate long path with \..\ characters
 Z$ = C$ + ":\" + D$
 DO
    IF LEN(Z$) > 32 THEN
       V1 = INSTR(Z$, "\")
       IF V1 > 0 THEN
          DO
             IF MID$(Z$, V1, 4) = "\..\" THEN
                V1 = INSTR(V1 + 1, Z$, "\")
             ELSE
                EXIT DO
             END IF
          LOOP
          V2 = INSTR(V1 + 1, Z$, "\")
          IF V2 > 0 THEN
             Z$ = LEFT$(Z$, V1) + ".." + MID$(Z$, V2)
          END IF
       END IF
    ELSE
       EXIT DO
    END IF
 LOOP
 DO
    V = INSTR(Z$, "\..\..\")
    IF V > 0 THEN
       Z$ = LEFT$(Z$, V - 1) + "\..\" + MID$(Z$, V + 7)
    ELSE
       EXIT DO
    END IF
 LOOP
 LOCATE 3 + Xcoor - 1, 3 + Ycoor - 1, 1
 PRINT SPACE$(32);
 LOCATE 3 + Xcoor - 1, 3 + Ycoor - 1, 1
 PRINT Z$
 RETURN

' load specified files.
LoadFileSpec:
 REDIM Filenames(1 TO 128) AS STRING * 64
 Max.Files = 64
 Num.Files = 0
 GOSUB SetDTA
 ' find first file
 ASCIIZ3 = F$ + CHR$(0)
 InregsX.AX = &H4E00
 InregsX.CX = &H27
 InregsX.DS = VARSEG(ASCIIZ3)
 InregsX.DX = VARPTR(ASCIIZ3)
 CALL InterruptX(&H21, InregsX, OutregsX)
 ' store files
 DO
    ' check findnext error
    IF (OutregsX.Flags AND &H1) = &H1 THEN
       EXIT DO
    END IF
    ' check for file
    Attribute = ASC(DTAfile.FileBits)
    IF (Attribute AND &H10) <> &H10 THEN
       E$ = DTAfile.ASCIIZfilename
       E$ = LEFT$(E$, INSTR(E$, CHR$(0)) - 1)
       Num.Files = Num.Files + 1
       Filenames(Num.Files) = E$
       IF Num.Files >= Max.Files THEN
          OPEN "hexedit2.dat" FOR OUTPUT AS #1
          FOR Var& = 1 TO Num.Files
             PRINT #1, Filenames(Var&)
          NEXT
          CLOSE #1
          Max.Files = Max.Files + 64
          REDIM Filenames(1 TO Max.Files) AS STRING * 64
          OPEN "hexedit2.dat" FOR INPUT AS #1
          FOR Var& = 1 TO Num.Files
             INPUT #1, Filenames(Var&)
          NEXT
          CLOSE #1
       END IF
    END IF
    ' find next file
    InregsX.AX = &H4F00
    CALL InterruptX(&H21, InregsX, OutregsX)
 LOOP
 GOSUB ResetDTA
 LOCATE Xcoor + 3, Ycoor + 9
 PRINT SPACE$(10);
 LOCATE Xcoor + 3, Ycoor + 9
 COLOR 15
 PRINT "("+MID$(STR$(Num.Files),2)+")";
 COLOR 7
 GOSUB Shell.Sort1
 RETURN
 ' bubble sort
 FOR V1 = 1 TO Num.Files
    FOR V2 = V1 + 1 TO Num.Files
       IF Filenames(V1) > Filenames(V2) THEN
          SWAP Filenames(V1), Filenames(V2)
       END IF
    NEXT
 NEXT
 RETURN

DisplayFileSpec:
 VarX = 0
 DO
    VarX = VarX + 1
    IF VarX > 10 THEN
       EXIT DO
    END IF
    IF VarX > Num.Files THEN
       EXIT DO
    END IF
    LOCATE VarX + 5 + Xcoor - 1, 4 + Ycoor - 1, 1
    E$ = Filenames(VarX)
    E$ = RTRIM$(E$)
    PRINT E$;
 LOOP
 RETURN

ClearFileBox:
 FOR VarX = 1 TO 10
    LOCATE VarX + 5 + Xcoor - 1, 4 + Ycoor - 1, 1
    PRINT SPACE$(12);
 NEXT
 RETURN

' assign program dta.
SetDTA:
 InregsX.AX = &H1A00
 InregsX.DS = VARSEG(DTAfile)
 InregsX.DX = VARPTR(DTAfile)
 CALL InterruptX(&H21, InregsX, OutregsX)
 RETURN

' restore basic dta.
ResetDTA:
 InregsX.AX = &H1A00
 InregsX.DS = BASIC.DTA.SEG
 InregsX.DX = BASIC.DTA.OFF
 CALL InterruptX(&H21, InregsX, OutregsX)
 RETURN

StripName:
 DO
    Strip = INSTR(X$, ":")
    IF Strip THEN
       I$ = MID$(X$, Strip + 1)
    ELSE
       EXIT DO
    END IF
 LOOP
 DO
    Strip = INSTR(X$, "\")
    IF Strip THEN
       I$ = MID$(X$, Strip + 1)
    ELSE
       EXIT DO
    END IF
 LOOP
 RETURN

' sort filenames() array
Shell.Sort1:
 IF Num.Files<2 THEN
    RETURN
 END IF
 Num = Num.Files
 Span = INT(Num / 2)
 DO WHILE Span > False
    FOR Start = Span TO Num - 1
       FOR Element = (Start - Span + 1) TO 1 STEP -Span
          Sort.Column1$ = RTRIM$(Filenames(Element))
          Sort.Column2$ = RTRIM$(Filenames(Element + Span))
          IF Sort.Column1$ <= Sort.Column2$ THEN
             EXIT FOR
          END IF
          SWAP Filenames(Element), Filenames(Element + Span)
       NEXT
    NEXT
    Span = INT(Span / 2)
 LOOP
 RETURN

' sorts directories() array
Shell.Sort2:
 IF Num.Dirs<2 THEN
    RETURN
 END IF
 Num = Num.Dirs
 Span = INT(Num / 2)
 DO WHILE Span > False
    FOR Start = Span TO Num - 1
       FOR Element = (Start - Span + 1) TO 1 STEP -Span
          Sort.Column1$ = RTRIM$(Directories(Element))
          Sort.Column2$ = RTRIM$(Directories(Element + Span))
          IF Sort.Column1$ <= Sort.Column2$ THEN
             EXIT FOR
          END IF
          SWAP Directories(Element), Directories(Element + Span)
       NEXT
    NEXT
    Span = INT(Span / 2)
 LOOP
 RETURN
END SUB
